| Bsoft 1.9 Bernard's software package

- Main Page
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Classes | Functions
img_graphseg.h File Reference

Header file for segmenting images into density regions using a nondirected graph. More...

`#include "rwimg.h"`

Go to the source code of this file.

## Classes
struct | Edge
struct | Region

## Functions
size_t | img_graph_segment (int type, Bimage *p, Bimage *pmask, int connect_type, double complexity, int min_size)
| Graph-based segmentation of an image. More...

## Detailed Description

Header file for segmenting images into density regions using a nondirected graph.

Author
  Bernard Heymann

Date
  Created: 20110318
  Modified: 20110328

Definition in file img_graphseg.h.

## Function Documentation

size_t img_graph_segment | ( | int | type,
|  | Bimage * | p,
|  | Bimage * | pmask,
|  | int | connect_type,
|  | double | complexity,
|  | int | min_size
| ) |  |

Graph-based segmentation of an image.

Parameters

  type | segmentation type: 1=threshold, 2=statistical region merging.
  *p | image.
  *pmask | mask to limit areas for segmentation.
  connect_type | connection type: 0=direct neighbors, 1=all neighbors.
  complexity | a value determining the number of segments.
  min_size | minimum segment size.

Returns
  size_t number of segments.

      An array of edges between neighboring voxels is set up and sorted in
      non-decreasing order. The voxels are then aggregated into regions based
      on two selectable criteria:
      simple      edge difference with adjustable threshold.
      srm         statistical region merging.
      Regions below a given cutoff size are merged.
      Only the first sub-image is segmented.

      IEEE Trans. Pattern Anal. Mach. Intell. 26(11): 1452-1458 (2004)

  Reference: R. Nock, F. Nielsen: Statistical Region Merging.

Definition at line 233 of file img_graphseg.cpp.